/*-------------------------------------------------*\
 deMarki (defjammer)
 The JavaScript for Adobe Illustrator CS & higer
 ---------------------------------------------------

 version: 0.7 (beta)
 author: vd
 contacts: vd@online.com.ua

 This software is distributed under the terms of 
 GNU General Public License.
 http://www.gnu.org/licenses/gpl.html
 
 Note: If you wish to incorporate parts of the 
 script into other programs whose distribution 
 conditions are different, write to the author 
 to ask for permission. 
\*-------------------------------------------------*/


$.level = 2;
var mm = 72/25.4


  markWeight = 0.2
  markLength = 4 *mm
  markOffset = markWeight *1.5
  minOffset  = 2 *mm 

  cBar1 = 100
  cBar2 = 50

sigString = "\u0421\u0438\u0433\u043D\u0430\u0442\u0443\u0440\u0430 \u0441\u043F\u0443\u0441\u043A\u0430:";
inputStr = "\u0412\u0432\u0435\u0434\u0438\u0442\u0435 \u043F\u0430\u0440\u0430\u043C\u0435\u0442\u0440\u044B \u0447\u0435\u0440\u0435\u0437 \u043F\u0440\u043E\u0431\u0435\u043B\n[w:nx h:ny b]\nw, h - \u043E\u0431\u0440\u0435\u0437\u043D\u0430\u044F \u0448\u0438\u0440\u0438\u043D\u0430 \u0438 \u0432\u044B\u0441\u043E\u0442\u0430 \u0438\u0437\u0434\u0435\u043B\u0438\u044F; nx, ny - \u043A\u043E\u043B\u0438\u0447\u0435\u0441\u0442\u0432\u043E \u0438\u0437\u0434\u0435\u043B\u0438\u0439 \u043F\u043E \u0433\u043E\u0440\u0438\u0437\u043E\u043D\u0442\u0430\u043B\u0438 \u0438 \u0432\u0435\u0440\u0442\u0438\u043A\u0430\u043B\u0438; b - \u0432\u044B\u0441\u0442\u0443\u043F \u0437\u0430 \u043E\u0431\u0440\u0435\u0437";
inputAutoStr = "\u0412\u0432\u0435\u0434\u0438\u0442\u0435 \u0432\u044B\u043F\u0443\u0441\u043A \u0437\u0430 \u043E\u0431\u0440\u0435\u0437 (bleed)";
norunStr = "\u0423\u0441\u043B\u043E\u0432\u0438\u044F \u0432\u044B\u043F\u043E\u043B\u043D\u0435\u043D\u0438\u044F \u0441\u043A\u0440\u0438\u043F\u0442\u0430:\n* \u041E\u0442\u043A\u0440\u044B\u0442\u044B\u0439 \u0434\u043E\u043A\u0443\u043C\u0435\u043D\u0442\n* \u041F\u0440\u0430\u0432\u0438\u043B\u044C\u043D\u043E \u0432\u0432\u0435\u0434\u0435\u043D\u043D\u044B\u0435 \u043F\u0430\u0440\u0430\u043C\u0435\u0442\u0440\u044B";
distribStr = "\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0438\u0442\u044C \u043E\u0431\u044A\u0435\u043A\u0442 \u043F\u043E \u043B\u0438\u0441\u0442\u0443?";

makeRegMarks = makeRegMarks_OldStyle;
// makeRegMarks = makeRegMarks_Standard;

var paperColor = new CMYKColor();
paperColor.cyan = 0; 
paperColor.magenta = 0; 
paperColor.yellow = 0; 
paperColor.black = 0;

var inkNames = new Array();

if ( documents.length > 0 )
{
	doc = activeDocument;

	var regColor = new SpotColor();
	regColor.spot = doc.spots['[Registration]'];
	
	origin = doc.rulerOrigin;
	var start = true;


	if(sig = prompt(sigString, unescape(doc.fullName))) {
		dateStr = Date();
		dateStr = dateStr.substr(0,dateStr.length-9);
		sig += " (" + dateStr + ")";

		if(doc.selection instanceof Array && doc.selection.length == 1) {

			if(B = prompt(inputAutoStr, "2")) {
				var obj = doc.selection[0];
				B *= mm;
				zB = 0;
				if(B>(-1*minOffset) && B<minOffset)
					markOffset += minOffset - Math.abs(B);
				if(B<0) {
					zB = B;
					B = 0;
					markOffset -= zB;
				}

				var bnd = getBounds(obj);
				W = bnd[2]-bnd[0]+zB*2;
				H = bnd[1]-bnd[3]+zB*2;
				xN = Math.floor((doc.width-(markLength+markOffset)*2)/W);
				yN = Math.floor((doc.height-(markLength+markOffset)*2)/H);
			
				if(confirm(distribStr)) {
					ox = ((doc.width-(W*xN))/2)-origin[0]+(obj.left - bnd[0]);
					oy = ((doc.height-(H*yN))/2)-origin[1]+(obj.top - bnd[1]);
					for(i=0; i<xN; i++) 
					for(j=1; j<=yN; j++) {
						objCopy = obj.duplicate(obj.parent);
						objCopy.left = ox+zB+i*W;
						objCopy.top = oy-zB+j*H;
					}
					obj.remove();
				}
			}
			else start = false;
		}
		else 
			if(cmd = prompt(inputStr, "90:4 50:5 2")) {
				param = cmd.split(' ');
				B = param[2] *mm;
				tmp = param[0].split(':');
				W = tmp[0] *mm;
				xN = tmp[1];
				tmp = param[1].split(':');
				H = tmp[0] *mm;
				yN = tmp[1];
		
				W += B*2;
				H += B*2;		
			}
			else start = false;
	}
	else start = false;

	if(start) {
		var mLayer= doc.layers.add();
		mLayer.name = '_Marki';

		tW = W*xN;
		tH = H*yN;
		oX = ((doc.width-tW)/2)-origin[0];
		oY = ((doc.height-tH)/2)-origin[1];

		colors = inkArray(doc);

		var SIGLayer= mLayer.layers.add();
		SIGLayer.name = '_Signature';
		var CBLayer= mLayer.layers.add();
		CBLayer.name = '_Color Bars';

		for(i=0; i<inkNames.length; i++) {

			// Color Marks
			cText = CBLayer.textFrames.add();
			cText.contents = inkNames[i];
			cText.textRange.size = 8;
			cText.textRange.fillColor = colors[i*2];
			cText.textRange.overprintFill = true;
			cText.rotate(90);
			cText.position = Array(oX+tW+markLength+markOffset, oY+tH);
			cText.createOutline();

			// Signature
			iText = SIGLayer.textFrames.add();
			iText.contents = sig;
			iText.textRange.size = 8;
			iText.textRange.fillColor = colors[i*2];
			iText.textRange.overprintFill = true;
			iText.rotate(90);
			iText.position = Array(oX-markLength-markOffset-12, oY+tH);
			iText = iText.createOutline();
			iText.name = '_Signature';		
		}

		// Color Bars

		nBar = Math.floor((tW-B*2)/markLength)-1;
		cBarX = oX+(tW-nBar*markLength)/2;
		cBarY = oY+tH+markOffset+markLength*1.5;
		for(i=0; i<nBar; i++) bar(CBLayer,cBarX+i*markLength,cBarY,markLength,markLength,colors[i%colors.length]);

		// Registration Marks

		var RegLayer= mLayer.layers.add();
		RegLayer.name = '_Registration Marks';
		makeRegMarks(RegLayer);	


		// Trim Marks

		var TrimLayer= mLayer.layers.add();
		TrimLayer.name = '_Trim Marks';
	
		if(B>0) {
			for(i=0; i<xN; i++) {
				line(TrimLayer, oX+W*i+B, oY-markOffset, oX+W*i+B, oY-markOffset-markLength, regColor, markWeight);
				line(TrimLayer, oX+W*i+W-B, oY-markOffset, oX+W*i+W-B, oY-markOffset-markLength, regColor, markWeight);
				line(TrimLayer, oX+W*i+B, oY+tH+markOffset, oX+W*i+B, oY+tH+markOffset+markLength, regColor, markWeight);
				line(TrimLayer, oX+W*i+W-B, oY+tH+markOffset, oX+W*i+W-B, oY+tH+markOffset+markLength, regColor, markWeight);
			}
			for(i=0; i<yN; i++) {
				line(TrimLayer, oX-markOffset, oY+H*i+B, oX-markOffset-markLength, oY+H*i+B, regColor, markWeight);
				line(TrimLayer, oX-markOffset, oY+H*i+H-B, oX-markOffset-markLength, oY+H*i+H-B, regColor, markWeight);
				line(TrimLayer, oX+tW+markOffset, oY+H*i+B, oX+tW+markOffset+markLength, oY+H*i+B, regColor, markWeight);
				line(TrimLayer, oX+tW+markOffset, oY+H*i+H-B, oX+tW+markOffset+markLength, oY+H*i+H-B, regColor, markWeight);
			}
		}
		else {
			for(i=0; i<=xN; i++) {
				line(mLayer, oX+W*i, oY-markOffset, oX+W*i, oY-markOffset-markLength, regColor, markWeight);
				line(mLayer, oX+W*i, oY+tH+markOffset, oX+W*i, oY+tH+markOffset+markLength, regColor, markWeight);
			}
			for(i=0; i<=yN; i++) {
				line(mLayer, oX-markOffset, oY+H*i, oX-markOffset-markLength, oY+H*i, regColor, markWeight);
				line(mLayer, oX+tW+markOffset, oY+H*i, oX+tW+markOffset+markLength, oY+H*i, regColor, markWeight);
			}
		}
		
	}
}
else
{
	alert(norunStr);
}

function line(parent,x1,y1,x2,y2,color,weight) 
{
	var line = parent.pathItems.add();
	line.stroked = true;
	line.filled = false;
	line.strokeWidth = weight*4;
	line.strokeColor = paperColor;
	line.setEntirePath( Array( Array(x1, y1), Array(x2, y2) ) );
	line = null;

	var line = parent.pathItems.add();
	line.stroked = true;
	line.filled = false;
	line.strokeWidth = weight;
	line.strokeColor = color;
	line.setEntirePath( Array( Array(x1, y1), Array(x2, y2) ) );
	line = null;
}

function cline(parent,x1,y1,x2,y2,color,weight) 
{
	var line = parent.pathItems.add();
	line.stroked = true;
	line.filled = false;
	line.strokeWidth = weight;
	line.strokeColor = color;
	line.setEntirePath( Array( Array(x1, y1), Array(x2, y2) ) );
	line = null;
}

function circle(parent,x,y,r,color,weight) 
{
	var ellipse = parent.pathItems.ellipse( y+r/2, x-r/2, r, r);
	ellipse.stroked = true;
	ellipse.filled = false;
	ellipse.strokeWidth = weight;
	ellipse.strokeColor = color;
	ellipse = null;
}

function bar(parent,x,y,w,h,color)
{
	var rect = parent.pathItems.rectangle(y,x,w,h);
	rect.stroked = false;
	rect.filled = true;
	rect.fillColor = color;
	rect = null;	
}

function regMark(parent,x,y,r,color,weight)
{
	var r2 = r/2;
	rm = parent.groupItems.add();

	var rect = rm.pathItems.rectangle(y+r2,x-r2,r,r);
	rect.stroked = false;
	rect.filled = true;
	rect.fillColor = paperColor;
	rect = null;

	cline(rm, x, y-r2, x, y+r2, paperColor, weight*3);
	cline(rm, x-r2, y, x+r2, y, paperColor, weight*3);
	circle(rm, x, y, r, paperColor, weight*3);

	cline(rm, x, y-r2, x, y+r2, color, weight);
	cline(rm, x-r2, y, x+r2, y, color, weight);
	circle(rm, x, y, r, color, weight);
}

function regMarkH(parent,x,y,r,color,weight)
{
	rm = parent.groupItems.add();
	var r2 = r/2;

	var rect = rm.pathItems.rectangle(y+r2,x-r2*3,r2*6,r);
	rect.stroked = false;
	rect.filled = true;
	rect.fillColor = paperColor;
	rect = null;

	cline(rm, x, y-r2, x, y+r2, paperColor, weight*3);
	cline(rm, x-r, y, x+r, y, paperColor, weight*3);
	circle(rm, x, y, r, paperColor, weight*3);

	cline(rm, x, y-r2, x, y+r2, color, weight);
	cline(rm, x-r, y, x+r, y, color, weight);
	circle(rm, x, y, r, color, weight);
}

function regMarkW(parent,x,y,r,color,weight)
{
	rm = parent.groupItems.add();
	var r2 = r/2;

	/*
	var rect = rm.pathItems.rectangle(y+r,x-r2,r,r*2);
	rect.stroked = false;
	rect.filled = true;
	rect.fillColor = paperColor;
	rect = null;
	*/

	cline(rm, x, y-r, x, y+r, paperColor, weight*3);
	cline(rm, x-r2, y, x+r2, y, paperColor, weight*3);
	circle(rm, x, y, r, paperColor, weight*3);

	cline(rm, x, y-r, x, y+r, color, weight);
	cline(rm, x-r2, y, x+r2, y, color, weight);
	circle(rm, x, y, r, color, weight);
}

function makeRegMarks_OldStyle(layer) {
	regMarkH(layer,doc.width/2-origin[0],oY-markLength/2-markOffset,markLength,regColor,markWeight);
	regMarkH(layer,doc.width/2-origin[0],oY+markLength/2+markOffset+tH,markLength,regColor,markWeight);

	regMarkW(layer,oX+markLength/2+markOffset+tW,doc.height/2-origin[1],markLength,regColor,markWeight);
	regMarkW(layer,oX-markLength/2-markOffset,doc.height/2-origin[1],markLength,regColor,markWeight);
}

function makeRegMarks_Standard(layer) {
	regMark(layer,oX+markLength/2+markOffset+B,oY-markLength/2-markOffset,markLength,regColor,markWeight);
	regMark(layer,oX-markLength/2-markOffset,oY+markLength/2+markOffset+B,markLength,regColor,markWeight);
	
	regMark(layer,oX+markLength/2+markOffset+B,oY+markLength/2+markOffset+tH,markLength,regColor,markWeight);
	regMark(layer,oX-markLength/2-markOffset,oY-markLength/2-markOffset-B+tH,markLength,regColor,markWeight);
	
	regMark(layer,oX-markLength/2-markOffset-B+tW,oY-markLength/2-markOffset,markLength,regColor,markWeight);
	regMark(layer,oX+markLength/2+markOffset+tW,oY+markLength/2+markOffset+B,markLength,regColor,markWeight);
	
	regMark(layer,oX-markLength/2-markOffset-B+tW,oY+markLength/2+markOffset+tH,markLength,regColor,markWeight);
	regMark(layer,oX+markLength/2+markOffset+tW,oY-markLength/2-markOffset-B+tH,markLength,regColor,markWeight);
}

function getBounds(obj) 
{
	var vbounds = new Array();

	if( (obj.typename == 'GroupItem') && !obj.clipped ) {
		vbounds = getBounds(obj.pageItems[0]);
		for( n=1; n<obj.pageItems.length; n++  ) {
			vgb = getBounds(obj.pageItems[n]);
			if( vbounds[0] > vgb[0] ) vbounds[0] = vgb[0];
			if( vbounds[1] < vgb[1] ) vbounds[1] = vgb[1];
			if( vbounds[2] < vgb[2] ) vbounds[2] = vgb[2];
			if( vbounds[3] > vgb[3] ) vbounds[3] = vgb[3];
		}
	}
	else if( (obj.typename == 'GroupItem') && obj.clipped && (obj.pageItems.length > 1) ) {
		vbounds = getBounds(obj.pageItems[0]);
		
		cvgb = getBounds(obj.pageItems[1]);
		objleft = cvgb[0];
		objtop = cvgb[1];
		objright = cvgb[2];
		objbottom = cvgb[3];
		
		obj.pageItems[0].stroked ? so = 0 : so = 1;
		for( n=so; n<obj.pageItems.length; n++ ) {
			cvgb = getBounds(obj.pageItems[n]);
			if( objleft > cvgb[0] ) objleft = cvgb[0];
			if( objtop < cvgb[1] ) objtop = cvgb[1];
			if( objright < (cvgb[2]) ) objright = cvgb[2];
			if( objbottom > (cvgb[3]) ) objbottom = cvgb[3];
		}
		if( vbounds[0] < objleft ) vbounds[0] = objleft;
		if( vbounds[1] > objtop ) vbounds[1] = objtop;
		if( vbounds[2] > objright ) vbounds[2] = objright;
		if( vbounds[3] < objbottom ) vbounds[3] = objbottom;
	}
	else {
		vbounds = obj.visibleBounds;
	}

	return vbounds;
}

function inkArray(dc) 
{
	Colors = new Array();

	for(i=0; i<dc.inkList.length; i++) 
	if(dc.inkList[i].inkInfo.printingStatus == InkPrintStatus.ENABLEINK) {
		inkNames.push(dc.inkList[i].name);
		switch(dc.inkList[i].inkInfo.kind) {
			case InkType.CYANINK:
				pColor = new CMYKColor();
				pColor.cyan = cBar1;
				pColor.magenta = 0; 
				pColor.yellow = 0; 
				pColor.black = 0;
				Colors.push(pColor);
				pColor = null;

				pColor = new CMYKColor();
				pColor.cyan = cBar2;
				pColor.magenta = 0; 
				pColor.yellow = 0; 
				pColor.black = 0;
				Colors.push(pColor);
				pColor = null;

				break;

			case InkType.MAGENTAINK:
				pColor = new CMYKColor();
				pColor.cyan = 0;
				pColor.magenta = cBar1;
				pColor.yellow = 0; 
				pColor.black = 0;
				Colors.push(pColor);
				pColor = null;

				pColor = new CMYKColor();
				pColor.cyan = 0;
				pColor.magenta = cBar2; 
				pColor.yellow = 0; 
				pColor.black = 0;
				Colors.push(pColor);
				pColor = null;

				break;

			case InkType.YELLOWINK:
				pColor = new CMYKColor();
				pColor.cyan = 0;
				pColor.magenta = 0;
				pColor.yellow = cBar1; 
				pColor.black = 0;
				Colors.push(pColor);
				pColor = null;

				pColor = new CMYKColor();
				pColor.cyan = 0;
				pColor.magenta = 0; 
				pColor.yellow = cBar2; 
				pColor.black = 0;
				Colors.push(pColor);
				pColor = null;

				break;

			case InkType.BLACKINK:
				pColor = new CMYKColor();
				pColor.cyan = 0;
				pColor.magenta = 0;
				pColor.yellow = 0; 
				pColor.black = cBar1;
				Colors.push(pColor);
				pColor = null;

				pColor = new CMYKColor();
				pColor.cyan = 0;
				pColor.magenta = 0; 
				pColor.yellow = 0; 
				pColor.black = cBar2;
				Colors.push(pColor);
				pColor = null;

				break;

			case InkType.CUSTOMINK:
				pColor = new SpotColor();
				pColor.spot = dc.spots.getByName(dc.inkList[i].name);
				pColor.tint = cBar1;
				Colors.push(pColor);
				pColor = null;

				pColor = new SpotColor();	
				pColor.spot = dc.spots.getByName(dc.inkList[i].name);
				pColor.tint = cBar2;
				Colors.push(pColor);
				pColor = null;

				break;	
		}
	}
	return Colors;
}